<script>
    /**
     * @param {any} json_uri
     */
    export function getImageLinkfromjson(json_uri) {
        var image_link = '';
        try {
            var json = JSON.parse(json_uri);
            for (const key in json) {
                if (key == 'image') {
                    var image_link = json[key];
                    break;
                }
                if (json[key].includes('ipfs')) {
                    var image_link = json[key];
                    break;
                }
            }

            return image_link;
        } catch (error) {
            return image_link;
        }
    }

    /**
     * @param {string} link
     */
    function ipfsLinkToUrl(link) {
        if (link.substring(0, 4).toLowerCase() != 'ipfs') {
            return link;
        }

        let temp = link.replace('/ipfs/', 'https://tradehands.peerplays.download/ipfs/');
        let image_url = temp.replace('ipfs://', 'https://tradehands.peerplays.download/ipfs/');

        return image_url;
    }

    // component parameter for token_uri: string
    export /**
     * @type {string}
     */
    let token_uri = '';

    //component parameter for image_link: string
    export /**
     * @type {string}
     */
    let image_link =
        token_uri.substring(0, 4).toLowerCase() === 'ipfs' ||
        token_uri.substring(0, 4).toLowerCase() === 'http'
            ? token_uri
            : getImageLinkfromjson(token_uri);

    //component parameter for image_src: string
    export /**
     * @type {string}
     */
    let image_src = ipfsLinkToUrl(image_link);
</script>

<div class="flex w-full h-full justify-center items-center">
    {#if image_src != ''}
        <img class="h-auto w-full" src={image_src} alt="NFT" />
    {:else}
        <h5>No image asset found</h5>
    {/if}
</div>
